Support a --quiet option in the test-suite.
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# For repeatability, reset the environment to known value.
7LANG=C
899460f3 8LC_ALL=C
d9bdd39e 9PAGER=cat
e1970ce4 10TZ=UTC
899460f3 11export LANG LC_ALL PAGER TZ
8ff99e74
EW
12EDITOR=:
13VISUAL=:
18508c39 14unset GIT_EDITOR
e1970ce4
JH
15unset AUTHOR_DATE
16unset AUTHOR_EMAIL
17unset AUTHOR_NAME
18unset COMMIT_AUTHOR_EMAIL
19unset COMMIT_AUTHOR_NAME
28a94f88 20unset EMAIL
e1970ce4
JH
21unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22unset GIT_AUTHOR_DATE
29e55cd5
JH
23GIT_AUTHOR_EMAIL=author@example.com
24GIT_AUTHOR_NAME='A U Thor'
6677c466 25unset GIT_COMMITTER_DATE
29e55cd5
JH
26GIT_COMMITTER_EMAIL=committer@example.com
27GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
28unset GIT_DIFF_OPTS
29unset GIT_DIR
892c41b9 30unset GIT_WORK_TREE
e1970ce4
JH
31unset GIT_EXTERNAL_DIFF
32unset GIT_INDEX_FILE
33unset GIT_OBJECT_DIRECTORY
34unset SHA1_FILE_DIRECTORIES
35unset SHA1_FILE_DIRECTORY
8d0fc48f
SP
36GIT_MERGE_VERBOSITY=5
37export GIT_MERGE_VERBOSITY
29e55cd5
JH
38export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
8ff99e74 40export EDITOR VISUAL
e1970ce4 41
886a3907
JH
42# Protect ourselves from common misconfiguration to export
43# CDPATH into the environment
44unset CDPATH
45
3d5c0cc9 46case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
47 1|2|true)
48 echo "* warning: Some tests will not work if GIT_TRACE" \
49 "is set as to trace on STDERR ! *"
50 echo "* warning: Please set GIT_TRACE to something" \
51 "other than 1, 2 or true ! *"
52 ;;
53esac
54
e1970ce4
JH
55# Each test should start with something like this, after copyright notices:
56#
57# test_description='Description of this test...
58# This test checks if command xyzzy does the right thing...
59# '
60# . ./test-lib.sh
61
55db1df0
PH
62[ "x$TERM" != "xdumb" ] &&
63 tput bold >/dev/null 2>&1 &&
64 tput setaf 1 >/dev/null 2>&1 &&
65 tput sgr0 >/dev/null 2>&1 &&
66 color=t
e1970ce4
JH
67
68test "${test_description}" != "" ||
69error "Test script did not set test_description."
70
71while test "$#" -ne 0
72do
73 case "$1" in
74 -d|--d|--de|--deb|--debu|--debug)
75 debug=t; shift ;;
886856ab
JH
76 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
77 immediate=t; shift ;;
e1970ce4
JH
78 -h|--h|--he|--hel|--help)
79 echo "$test_description"
80 exit 0 ;;
81 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
82 verbose=t; shift ;;
1ece1274
PH
83 -q|--q|--qu|--qui|--quie|--quiet)
84 quiet=t; shift ;;
55db1df0
PH
85 --no-color)
86 color=; shift ;;
abb7c7b3 87 --no-python)
7cdbff14
JH
88 # noop now...
89 shift ;;
e1970ce4
JH
90 *)
91 break ;;
92 esac
93done
94
55db1df0
PH
95if test -n "$color"; then
96 say_color () {
97 case "$1" in
98 error) tput bold; tput setaf 1;; # bold red
99 skip) tput bold; tput setaf 2;; # bold green
100 pass) tput setaf 2;; # green
101 info) tput setaf 3;; # brown
1ece1274 102 *) test -n "$quiet" && return;;
55db1df0
PH
103 esac
104 shift
105 echo "* $*"
106 tput sgr0
107 }
108else
109 say_color() {
1ece1274 110 test -z "$1" && test -n "$quiet" && return
55db1df0
PH
111 shift
112 echo "* $*"
113 }
114fi
115
116error () {
117 say_color error "error: $*"
118 trap - exit
119 exit 1
120}
121
122say () {
123 say_color info "$*"
124}
125
4d9d62fa 126exec 5>&1
e1970ce4
JH
127if test "$verbose" = "t"
128then
129 exec 4>&2 3>&1
130else
131 exec 4>/dev/null 3>/dev/null
132fi
133
134test_failure=0
135test_count=0
136
41184273
PR
137trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
138
04509738
JH
139test_tick () {
140 if test -z "${test_tick+set}"
141 then
21afc41c 142 test_tick=1112911993
04509738
JH
143 else
144 test_tick=$(($test_tick + 60))
145 fi
21afc41c
JH
146 GIT_COMMITTER_DATE="$test_tick -0700"
147 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
148 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
149}
e1970ce4 150
886856ab
JH
151# You are not expected to call test_ok_ and test_failure_ directly, use
152# the text_expect_* functions instead.
153
154test_ok_ () {
e1970ce4 155 test_count=$(expr "$test_count" + 1)
55db1df0 156 say_color "" " ok $test_count: $@"
e1970ce4
JH
157}
158
886856ab 159test_failure_ () {
e1970ce4
JH
160 test_count=$(expr "$test_count" + 1)
161 test_failure=$(expr "$test_failure" + 1);
55db1df0 162 say_color error "FAIL $test_count: $1"
bf0dd8a8
JH
163 shift
164 echo "$@" | sed -e 's/^/ /'
41184273 165 test "$immediate" = "" || { trap - exit; exit 1; }
886856ab
JH
166}
167
168
169test_debug () {
8e832ebc 170 test "$debug" = "" || eval "$1"
e1970ce4
JH
171}
172
4d9d62fa 173test_run_ () {
4d9d62fa
PR
174 eval >&3 2>&4 "$1"
175 eval_ret="$?"
4d9d62fa
PR
176 return 0
177}
178
04ece593
JH
179test_skip () {
180 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
181 this_test="$this_test.$(expr "$test_count" + 1)"
182 to_skip=
183 for skp in $GIT_SKIP_TESTS
184 do
185 case "$this_test" in
186 $skp)
187 to_skip=t
188 esac
189 done
190 case "$to_skip" in
191 t)
55db1df0 192 say_color skip >&3 "skipping test: $@"
04ece593 193 test_count=$(expr "$test_count" + 1)
55db1df0 194 say_color skip "skip $test_count: $1"
04ece593
JH
195 : true
196 ;;
197 *)
198 false
199 ;;
200 esac
201}
202
e1970ce4 203test_expect_failure () {
8e832ebc 204 test "$#" = 2 ||
e1970ce4 205 error "bug in the test script: not 2 parameters to test-expect-failure"
04ece593 206 if ! test_skip "$@"
e1970ce4 207 then
04ece593
JH
208 say >&3 "expecting failure: $2"
209 test_run_ "$2"
210 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
211 then
212 test_ok_ "$1"
213 else
214 test_failure_ "$@"
215 fi
e1970ce4 216 fi
7a0cf2d0 217 echo >&3 ""
e1970ce4
JH
218}
219
220test_expect_success () {
8e832ebc 221 test "$#" = 2 ||
e1970ce4 222 error "bug in the test script: not 2 parameters to test-expect-success"
04ece593 223 if ! test_skip "$@"
e1970ce4 224 then
04ece593
JH
225 say >&3 "expecting success: $2"
226 test_run_ "$2"
227 if [ "$?" = 0 -a "$eval_ret" = 0 ]
228 then
229 test_ok_ "$1"
230 else
231 test_failure_ "$@"
232 fi
e1970ce4 233 fi
7a0cf2d0 234 echo >&3 ""
e1970ce4
JH
235}
236
d3bfdb75
FK
237test_expect_code () {
238 test "$#" = 3 ||
239 error "bug in the test script: not 3 parameters to test-expect-code"
04ece593 240 if ! test_skip "$@"
d3bfdb75 241 then
04ece593
JH
242 say >&3 "expecting exit code $1: $3"
243 test_run_ "$3"
244 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
245 then
246 test_ok_ "$2"
247 else
248 test_failure_ "$@"
249 fi
d3bfdb75 250 fi
7a0cf2d0 251 echo >&3 ""
d3bfdb75
FK
252}
253
eedf8f97
CW
254# Most tests can use the created repository, but some amy need to create more.
255# Usage: test_create_repo <directory>
256test_create_repo () {
257 test "$#" = 1 ||
258 error "bug in the test script: not 1 parameter to test-create-repo"
259 owd=`pwd`
260 repo="$1"
261 mkdir "$repo"
262 cd "$repo" || error "Cannot setup test environment"
5c94f87e
NP
263 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
264 error "cannot run git init -- have you built things yet?"
eedf8f97
CW
265 mv .git/hooks .git/hooks-disabled
266 cd "$owd"
267}
a6080a0a 268
e1970ce4 269test_done () {
41184273 270 trap - exit
e1970ce4 271 case "$test_failure" in
10b94e28 272 0)
e1970ce4
JH
273 # We could:
274 # cd .. && rm -fr trash
275 # but that means we forbid any tests that use their own
276 # subdirectory from calling test_done without coming back
277 # to where they started from.
278 # The Makefile provided will clean this test area so
279 # we will leave things as they are.
280
55db1df0 281 say_color pass "passed all $test_count test(s)"
e1970ce4
JH
282 exit 0 ;;
283
284 *)
55db1df0 285 say_color error "failed $test_failure among $test_count test(s)"
e1970ce4
JH
286 exit 1 ;;
287
288 esac
289}
290
291# Test the binaries we have just built. The tests are kept in
292# t/ subdirectory and are run in trash subdirectory.
293PATH=$(pwd)/..:$PATH
a0fa2a10 294GIT_EXEC_PATH=$(pwd)/..
8683a45d 295GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
8565d2d8
JS
296GIT_CONFIG=.git/config
297export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
49ccb087 298
6fcca938
PB
299GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
300export GITPERLLIB
eea42069
JH
301test -d ../templates/blt || {
302 error "You haven't built things yet, have you?"
303}
e1970ce4 304
56cf9806
EW
305if ! test -x ../test-chmtime; then
306 echo >&2 'You need to build test-chmtime:'
307 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
308 exit 1
309fi
310
e1970ce4
JH
311# Test repository
312test=trash
313rm -fr "$test"
eedf8f97
CW
314test_create_repo $test
315cd "$test"
04ece593
JH
316
317this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
318for skp in $GIT_SKIP_TESTS
319do
320 to_skip=
321 for skp in $GIT_SKIP_TESTS
322 do
323 case "$this_test" in
324 $skp)
325 to_skip=t
326 esac
327 done
328 case "$to_skip" in
329 t)
55db1df0
PH
330 say_color skip >&3 "skipping test $this_test altogether"
331 say_color skip "skip all tests in $this_test"
04ece593
JH
332 test_done
333 esac
334done